import * as React from 'react';
import { Store } from 'redux';
import { StyledComponentProps } from '@material-ui/core';
import { IReduxServiceList, IReduxServiceDemoParams } from '../types';
export interface IActionFormProps extends StyledComponentProps {
    activeService: string;
    activeAction: string;
    services: IReduxServiceList;
    params: IReduxServiceDemoParams;
    store: Store<any>;
    handleActionSelect: (event: React.ChangeEvent<HTMLSelectElement>) => void;
}
export interface IActionFormState {
    formFields: string[];
    formValues: {
        [formKey: string]: string;
    };
}
export declare class ActionFormBase extends React.Component<IActionFormProps, IActionFormState> {
    componentWillMount(): void;
    componentWillReceiveProps({ services, activeService, activeAction, params }: IActionFormProps): void;
    handleFieldUpdate(event: React.ChangeEvent<HTMLInputElement>): void;
    handleSubmit(): void;
    render(): JSX.Element;
}
export declare const ActionForm: React.ComponentType<Pick<IActionFormProps, "activeService" | "activeAction" | "services" | "params" | "store" | "handleActionSelect"> & StyledComponentProps<"root" | "dispatchButton" | "stateMonitor" | "stateBody">>;
