var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import * as React from 'react';
import loglevel from 'loglevel';
import autobind from 'autobind-decorator';
import Button from '@material-ui/core/Button';
import Paper from '@material-ui/core/Paper';
import FormControl from '@material-ui/core/FormControl';
import Select from '@material-ui/core/Select';
import MenuItem from '@material-ui/core/MenuItem';
import { withStyles } from '@material-ui/core';
import { getActiveActionForm, getDefaultFormValues, parseFieldValue } from '../utilities';
import { ActionFormFields } from './ActionFormFields';
import { styles } from './ReduxServiceDemo.styles';
var ActionFormBase = /** @class */ (function (_super) {
    __extends(ActionFormBase, _super);
    function ActionFormBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ActionFormBase.prototype.componentWillMount = function () {
        var _a = this.props, services = _a.services, activeService = _a.activeService, activeAction = _a.activeAction, params = _a.params;
        var formFields = getActiveActionForm(services, activeService, activeAction);
        var formValues = getDefaultFormValues(formFields, params);
        this.setState({ formFields: formFields, formValues: formValues });
    };
    ActionFormBase.prototype.componentWillReceiveProps = function (_a) {
        var services = _a.services, activeService = _a.activeService, activeAction = _a.activeAction, params = _a.params;
        var formFields = getActiveActionForm(services, activeService, activeAction);
        var formValues = getDefaultFormValues(formFields, params);
        this.setState({ formFields: formFields, formValues: formValues });
    };
    ActionFormBase.prototype.handleFieldUpdate = function (event) {
        var _a;
        var _b = (this.state || {}).formValues, formValues = _b === void 0 ? {} : _b;
        var _c = event.target, id = _c.id, value = _c.value;
        var updatedFormValues = __assign({}, formValues, (_a = {}, _a[id] = parseFieldValue(value), _a));
        this.setState({ formValues: updatedFormValues });
    };
    ActionFormBase.prototype.handleSubmit = function () {
        var _a = this.props, services = _a.services, activeService = _a.activeService, activeAction = _a.activeAction, store = _a.store;
        var _b = this.state, formFields = _b.formFields, formValues = _b.formValues;
        var service = services[activeService];
        var actionDispatch = service.actions[activeAction];
        var params = Object.values(formValues);
        loglevel.info("handleSubmit|" + activeService + "|" + activeAction + "|", formValues);
        store.dispatch(actionDispatch.apply(void 0, params));
        var resetFormValues = getDefaultFormValues(formFields);
        this.setState({ formValues: resetFormValues });
    };
    ActionFormBase.prototype.render = function () {
        var _a = this.props, activeAction = _a.activeAction, activeService = _a.activeService, services = _a.services, handleActionSelect = _a.handleActionSelect, classes = _a.classes;
        var allActions = Object.keys(services[activeService].types);
        var formFields = getActiveActionForm(services, activeService, activeAction);
        var _b = (this.state || {}).formValues, formValues = _b === void 0 ? {} : _b;
        return (React.createElement(Paper, { square: true, className: classes.root },
            React.createElement(FormControl, { color: "default", margin: "dense", fullWidth: true },
                React.createElement(Select, { value: activeAction, onChange: handleActionSelect }, allActions.map(function (action) { return (React.createElement(MenuItem, { key: action, value: action }, action)); })),
                React.createElement(ActionFormFields, { formFields: formFields, formValues: formValues, handleFieldUpdate: this.handleFieldUpdate }),
                React.createElement(Button, { className: classes.dispatchButton, variant: "contained", color: "primary", onClick: this.handleSubmit }, "dispatch"))));
    };
    __decorate([
        autobind,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], ActionFormBase.prototype, "handleFieldUpdate", null);
    __decorate([
        autobind,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], ActionFormBase.prototype, "handleSubmit", null);
    return ActionFormBase;
}(React.Component));
export { ActionFormBase };
export var ActionForm = withStyles(styles)(ActionFormBase);
//# sourceMappingURL=ActionForm.js.map