var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import * as React from 'react';
import autobind from 'autobind-decorator';
import AppBar from '@material-ui/core/AppBar';
import Tabs from '@material-ui/core/Tabs';
import Tab from '@material-ui/core/Tab';
import Toolbar from '@material-ui/core/Toolbar';
import Typography from '@material-ui/core/Typography';
import { ActionForm } from './ActionForm';
import { config } from '../config';
import { StateMonitor } from './StateMonitor';
export var stateToString = function (state) { return JSON.stringify(state, null, 2); };
var ReduxServiceDemo = /** @class */ (function (_super) {
    __extends(ReduxServiceDemo, _super);
    function ReduxServiceDemo() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ReduxServiceDemo.prototype.componentWillMount = function () {
        var _this = this;
        var _a = this.props, params = _a.params, services = _a.services, store = _a.store;
        var allServices = Object.keys(services);
        var action = params.action, service = params.service;
        var activeService = service || allServices[0];
        var activeAction = action || Object.keys(services[activeService].types)[0];
        var stateString = stateToString(store.getState());
        this.setState({ activeService: activeService, activeAction: activeAction, stateString: stateString });
        store.subscribe(function () { return _this.setState({ stateString: stateToString(store.getState()) }); });
    };
    ReduxServiceDemo.prototype.handleActionSelect = function (event) {
        var value = event.target.value;
        this.setState({ activeAction: value });
    };
    ReduxServiceDemo.prototype.handleServiceSelect = function (event, activeService) {
        var services = this.props.services;
        var activeAction = Object.keys(services[activeService].types)[0];
        this.setState({ activeService: activeService, activeAction: activeAction });
    };
    ReduxServiceDemo.prototype.renderServiceTabs = function () {
        var services = this.props.services;
        var serviceNames = Object.keys(services);
        return serviceNames.map(function (item) { return (React.createElement(Tab, { value: item, key: item, label: item })); });
    };
    ReduxServiceDemo.prototype.render = function () {
        var _a = this.props, services = _a.services, params = _a.params, store = _a.store;
        var _b = this.state, activeService = _b.activeService, activeAction = _b.activeAction, stateString = _b.stateString;
        return (React.createElement("div", null,
            React.createElement(AppBar, { position: "static", color: "default" },
                React.createElement(Toolbar, null,
                    React.createElement(Typography, { variant: "h4", color: "inherit" }, config.title)),
                React.createElement(Tabs, { centered: true, value: activeService, onChange: this.handleServiceSelect }, this.renderServiceTabs())),
            React.createElement(ActionForm, { activeAction: activeAction, activeService: activeService, handleActionSelect: this.handleActionSelect, services: services, store: store, params: params }),
            React.createElement(StateMonitor, { stateString: stateString })));
    };
    __decorate([
        autobind,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], ReduxServiceDemo.prototype, "handleActionSelect", null);
    __decorate([
        autobind,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, String]),
        __metadata("design:returntype", void 0)
    ], ReduxServiceDemo.prototype, "handleServiceSelect", null);
    return ReduxServiceDemo;
}(React.Component));
export { ReduxServiceDemo };
//# sourceMappingURL=ReduxServiceDemo.js.map