import * as util from '../index';
test('isJsonString returns true for a valid json string', function () {
    expect(util.isJsonString('{ "foo": "bar" }')).toBe(true);
    expect(util.isJsonString('{ "boolean": true }')).toBe(true);
    expect(util.isJsonString('[ "foo", "bar" ]')).toBe(true);
});
test('isJsonString returns false for a invalid json string', function () {
    expect(util.isJsonString('foo')).toBe(false);
});
test('parseFieldValue will parse a string into a JSON object', function () {
    var aJsonString = '{ "foo": "bar" }';
    var result = util.parseFieldValue(aJsonString);
    expect(result).toEqual({ foo: 'bar' });
});
test('parseFieldValue will return a string as-is (no JSON parsing)', function () {
    var aJsonString = 'a string';
    var result = util.parseFieldValue(aJsonString);
    expect(result).toEqual('a string');
});
test('fieldValueForDisplay will convert an object into a string for display', function () {
    var anObject = { foo: 'bar' };
    var result = util.fieldValueForDisplay(anObject);
    expect(result).toEqual('{"foo":"bar"}');
});
test('fieldValueForDisplay will return a string as-is for display', function () {
    var aString = 'a string value';
    var result = util.fieldValueForDisplay(aString);
    expect(result).toEqual('a string value');
});
//# sourceMappingURL=helpers.test.js.map