var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import loglevel from 'loglevel';
import { initializeDemoStore } from './redux';
import { MuiThemeProvider } from '@material-ui/core/styles';
import { ReduxServiceDemo } from '../components/ReduxServiceDemo';
import { demoTheme } from '../components/ReduxServiceDemo.styles';
export var isJsonString = function (str) {
    try {
        JSON.parse(str);
    }
    catch (e) {
        return false;
    }
    return true;
};
export var parseFieldValue = function (value) { return (isJsonString(value) ? JSON.parse(value) : value); };
export var fieldValueForDisplay = function (value) { return (typeof (value) === 'object' ? JSON.stringify(value) : value); };
export var searchParams = function () { return new URLSearchParams(window.location.search).entries(); };
export function getParams() {
    var params = Array.from(searchParams());
    var reducer = function (allParams, entry) {
        var _a;
        var key = entry[0];
        var value = entry[1];
        return __assign({}, allParams, (_a = {}, _a[key] = value, _a));
    };
    return params.reduce(reducer, {});
}
function initDemoLogging() {
    loglevel.setLevel('INFO');
    loglevel.info('[redux-service-demo:0.2.0]');
}
export var renderDemo = function (services, container) {
    var demoStore = initializeDemoStore(services);
    var params = getParams();
    initDemoLogging();
    ReactDOM.render(React.createElement(MuiThemeProvider, { theme: demoTheme },
        React.createElement(ReduxServiceDemo, { services: services, params: params, store: demoStore })), container);
    return demoStore;
};
//# sourceMappingURL=helpers.js.map