var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { combineReducers, createStore, applyMiddleware, } from 'redux';
import reduxThunk from 'redux-thunk';
import reduxLogger from 'redux-logger';
import { config } from '../config';
export function initializeDemoStore(services) {
    var servicesReducer = function (state, service) {
        var _a;
        return (__assign({}, state, (_a = {}, _a[service] = services[service].reducer, _a)));
    };
    var allServiceReducers = Object.keys(services).reduce(servicesReducer, {});
    var combinedReducers = combineReducers(allServiceReducers);
    var middlewares = [reduxThunk];
    if (config.useLogger) {
        middlewares.push(reduxLogger);
    }
    return createStore(combinedReducers, applyMiddleware.apply(void 0, middlewares));
}
//# sourceMappingURL=redux.js.map